package com.zipcodewilmington.productmanager;

import javax.sound.midi.Soundbank;
import java.util.ArrayList;

public class Inventory {
    ArrayList<Product> inventory = new ArrayList<Product>();

    public void addProduct(String name, int id, double price, int quantity){
        if (!inventory.contains(name)) {
            inventory.add(new Product(name, id, price, quantity));
            System.out.printf("New item added | name:" + name + " | id: %03d | Price: $%3.2f | Quantity: %s\n", id, price, quantity);
        } else {
            System.out.printf(name + " already exists. " + "id: %03d | Price: $%3.2f | Quantity: %s\n", getIdByName(name), getPriceByName(name), getQuantByName(name));
        }
    }

    public void removeProduct(String name, int id){
        if(getIdByName(name) == id){
            inventory.remove(findProduct(id));
            System.out.printf(name + "(id: %03d) has been removed from inventory\n", id);
        } else {
            System.out.printf("The item \'" + name + "\' and id \'%03d\' + you entered do not match", id);
        }
    }

    public Product findProduct(String name){
        Product result = null;
        for(Product product : inventory){
            if (product.getName().equals(name)){
                result = product;
                break;
            } else if (!inventory.contains(product)){
                System.out.println("Can't find product by name given");
            }
        }
        return result;
    }

    public Product findProduct(int id){
        Product result = null;
        for(Product product : inventory){
            if (product.getId() == id){
                result = product;
            } else if (!inventory.contains(product)){
                System.out.println("Can't find product by id given");
            }
        }
        return result;
    }

    public int getIdByName(String name){
        if (findProduct(name) != null) {
            return findProduct(name).getId();
        } else {
            System.out.println(name + "Does not exist with name given");
            return 0;
        }
    }

    public double getPriceByName(String name){
        if (findProduct(name) != null) {
            return findProduct(name).getPrice();
        } else {
            System.out.println("Price for " + name + "does not exist with name given");
            return 0;
        }
    }

    public int getQuantByName(String name){
        if (findProduct(name) != null) {
            return findProduct(name).getQuantity();
        } else {
            System.out.println("Quantity for " + name + "does not exist with name given");
            return 0;
        }
    }

    public String getNameById(int id) {
        if (findProduct(id) != null) {
            return findProduct(id).getName();
        } else {
            System.out.printf("Product for \'id:%03d\' + does not exist with id given\n", id);
            return "";
        }
    }

    public int countItems(){
        int sum = 0;
        for(Product product : inventory){
            sum+=product.getQuantity();
        }
        System.out.println(sum + " total items in store.");
        return sum;
    }

    public int countProducts(){
        System.out.println(inventory.size() + " unique products in store.");
        return inventory.size();
    }
}
