package com.zipcodewilmington.productmanager;

import org.junit.Assert;
import org.junit.Test;

public class InventoryTest {
    Inventory inv = new Inventory();
    @Test
    public void addProductTest(){
        int preAdd = inv.inventory.size();
        inv.addProduct("Computer",100, 5.00,50);
        int postAdd = inv.inventory.size();

        int actual = postAdd - preAdd;
        int expected = 1;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeProductTest(){
        inv.addProduct("Computer",100,5.00,50);
        int preRem = inv.inventory.size();
        inv.removeProduct("Computer", 100);
        int postRem = inv.inventory.size();

        int actual = postRem - preRem;
        int expected = -1;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void findProductByNameTest(){
        inv.addProduct("Notebook", 101,1.00,30);
        inv.addProduct("Computer",100,5.00,50);
        String actual = inv.findProduct("Notebook").getName();
        //using getName() of Product class since it works. Don't know how to represent product since didn't instantiate it with a name
        String expected ="Notebook";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void findProductByIdTest(){
        inv.addProduct("Notebook", 101,1.00,30);
        inv.addProduct("Computer",100,5.00,50);
        //using getName() of Product class since it works. Don't know how to represent product since didn't instantiate it with a name
        String actual = inv.findProduct(101).getName();
        String expected ="Notebook";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getIdByNameTest(){
        inv.addProduct("Stapler", 103,2,20);
        int actual = inv.getIdByName("Stapler");
        int expected = 103;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getPriceByNameTest(){
        inv.addProduct("Stapler", 103,2,20);
        double actual = inv.getPriceByName("Stapler");
        double expected = 2;

        Assert.assertEquals(expected,actual,0.0099);
    }

    @Test
    public void getQuantByNameTest(){
        inv.addProduct("Stapler", 103,2,20);
        int actual = inv.getQuantByName("Stapler");
        int expected = 20;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getNamebyIdTest(){
        inv.addProduct("Stapler", 103,2,20);
        String actual = inv.getNameById(103);
        String expected = "Stapler";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void countItemsTest(){
        inv.addProduct("Notebook", 101,1.00,30);
        inv.addProduct("Computer",100,5.00,50);
        int actual = inv.countItems();
        int expected = 80;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void countProductsTest(){
        inv.addProduct("Notebook", 101,1.00,30);
        inv.addProduct("Computer",100,5.00,50);
        int actual = inv.countProducts();
        int expected = 2;

        Assert.assertEquals(expected,actual);
    }

}
